#include "BosheitRune.h"
#include "Spieler.h"


BosheitRuneEffect::BosheitRuneEffect( ResourceRegistry *zResources, Spieler *zSpieler )
    : Effect( zSpieler, 75.f + ( 75.f / 100.f ) * zSpieler->getAbklingZeitVerringerung() )
{
    zSpieler->setSchadenBonus( zSpieler->getSchadenBonus() + 7 );
    zSpieler->setLebensRaub( zSpieler->getLebensRaub() + 3 );
    annimation = zResources->getResource( R_RBOSHEIT_EFFECT, 0 );
    effectImage = zResources->zResource( R_RBOSHEIT, 0 )->getImage( 0 );
    currentImage = 0;
    nextImage = 0.075;
}

BosheitRuneEffect::~BosheitRuneEffect()
{
    zSpieler->setSchadenBonus( zSpieler->getSchadenBonus() - 7 );
    zSpieler->setLebensRaub( zSpieler->getLebensRaub() - 3 );
    annimation->release();
}

bool BosheitRuneEffect::tick( double time, Spiel *zSpiel )
{
    nextImage -= time;
    if( nextImage <= 0 )
    {
        nextImage += 0.075;
        currentImage++;
    }
    return Effect::tick( time, zSpiel );
}

void BosheitRuneEffect::renderSpieler( Bild &rObj )
{
    if( currentImage >= annimation->getImageCount() )
        return;
    if( rObj.setDrawOptions( (int)zSpieler->getX(), (int)zSpieler->getY(), (int)zSpieler->getWidth(), (int)zSpieler->getHeight() ) )
    {
        rObj.alphaBildSkall( 0, 0, (int)zSpieler->getWidth(), (int)zSpieler->getHeight(), *annimation->zImage( currentImage ) );
        rObj.releaseDrawOptions();
    }
}